import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.NoSuchElementException;
import java.util.Random;

public class MyLinkedList<T extends Comparable<? super T>> implements Iterable<T >{

	private Node head;
	private int size;
		
	public MyLinkedList() {
		this.head = null;
		this.size = 0;
	}
	
	public boolean add(T e) {
		if (head == null) {
			head = new Node(e);
			size++;
			return true;
		}
		Node temp = new Node(e);
		temp.next = head;
		head = temp;
		size++;
		return true;
	}
	
	/**
	 * This method is used to insert into an already sorted list
	 * to maintain a sorted list. The list may contain duplicates.
	 * This method runs in O(N) time.
	 * @param e The element to be inserted.
	 * @return Returns true, if the element was successfully inserted 
	 * and false otherwise. 
	 */
	public boolean insert(T e) {
		return false;
	}
	
	/**
	 * This method checks whether all elements of the Collection c
	 * are contained in this MyLinkedList. This method runs in O(c*N) time.
	 * @param c The Collection to be checked.
	 * @return true, is all elements in c are contained in this
	 * MyLinkedList and false otherwise.
	 */
			
	public boolean containsAll(Collection<? extends T> c) {
		return false;
	}
	
	public int size() {
		return this.size;
	}
	
	private class Node{
		private T element;
		private Node next;
		
		public Node(T element) {
			this.element = element;
			this.next = null;
		}
		
		public void toArrayList(ArrayList<T> a) {
			a.add(this.element);
			if (this.next != null) this.next.toArrayList(a);
		}
	}

		public boolean isEmpty() {
			return head == null;
		}

		public boolean contains(T o) {
			Iterator<T> it = iterator();
			while (it.hasNext()) {
				if (it.next().equals(o)) return true;
			}
			return false;
		}
		
		public ArrayList<T> toArrayList() {
			ArrayList<T> a = new ArrayList<>();
			if (head != null) head.toArrayList(a);
			return a;
		}
		
		public Iterator<T> iterator() {
			return new AscendingIterator();
		}
		
		private class AscendingIterator implements Iterator<T> {
			private Node current;
			
			public AscendingIterator() {
				current = head;
			}

			public boolean hasNext() {
				return current != null;
			}

			public T next() {
				if (!hasNext()) throw new NoSuchElementException();
				T element = current.element;
				current = current.next;
				return element;
			}

		}
}
